﻿using System;
using System.Linq;
using System.Threading.Tasks;
using Microsoft.AspNetCore.Mvc;

using System.IO;
using System.Data;
using System.Data.SqlClient;
using ClosedXML.Excel;

namespace DataTable_Excel_MVC_Core
{
    public class HomeController : Controller
    {
        // GET: Home
        public IActionResult Index()
        {
            DataSet ds = this.GetCustomers();
            return View(ds);
        }

        [HttpPost]
        public IActionResult Export()
        {
            using (XLWorkbook wb = new XLWorkbook())
            {
                DataTable dt = this.GetCustomers().Tables[0];
                wb.Worksheets.Add(dt);
                using (MemoryStream stream = new MemoryStream())
                {
                    wb.SaveAs(stream);
                    return File(stream.ToArray(), "application/vnd.openxmlformats-officedocument.spreadsheetml.sheet", "Grid.xlsx");
                }
            }
        }

        private DataSet GetCustomers()
        {
            DataSet ds = new DataSet();
            string constr = @"Data Source=.\SQL2019;Initial Catalog=AjaxSamples;Integrated Security=true";
            using (SqlConnection con = new SqlConnection(constr))
            {
                string query = "SELECT * FROM Customers";
                using (SqlCommand cmd = new SqlCommand(query))
                {
                    cmd.Connection = con;
                    using (SqlDataAdapter sda = new SqlDataAdapter(cmd))
                    {
                        sda.Fill(ds);
                    }
                }
            }

            return ds;
        }
    }
}